#include <malloc.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>

#ifndef min
int min(int a, int b) { return (a<b) ? a : b; }
#endif

unsigned char GetRed(unsigned int rgb) { return (unsigned char) (rgb); }

unsigned char GetGreen(unsigned int rgb) { return (unsigned char) (rgb >> 8); }

unsigned char GetBlue(unsigned int rgb) { return (unsigned char) (rgb >> 16); }

#ifndef RGB
unsigned int RGB(unsigned char r, unsigned char g, unsigned char b)
{
	return (((unsigned int)(b) << 16) |
			((unsigned int)(g) << 8) |
			((unsigned int)(r))
		);
};
#endif

void Color2HEX(int color, char* strColor)
{
	unsigned char R, G, B;
	R = GetRed(color);
	G = GetGreen(color);
	B = GetBlue(color);

	sprintf(strColor,"%06X", RGB(B,G,R));
}

void HEX2Color(char* strColor, int* color)
{
	unsigned char R, G, B;
	unsigned int tmpColor = 0x000000;

	char hexStr[] = "000000";
	int n, len = strlen(strColor);
	len = min(6, len);
	n = 6-len;
	strncpy(hexStr + n, strColor, n);
	sscanf(hexStr, "%6x", &tmpColor);

	R = GetRed(tmpColor);
	G = GetGreen(tmpColor);
	B = GetBlue(tmpColor);

	*color = RGB(B,G,R);
}
